ghc-7.8.4: The GHC API

Safe Haskell | None
Language | Haskell98

TcTyDecls

# Documentation

calcRecFlags :: ModDetails -> Bool -> RoleAnnots -> [TyThing] -> RecTyInfo

data RecTyInfo

Constructors

RTI |

Fields

rti_promotable :: Bool
rti_roles :: Name -> [Role]
rti_is_rec :: Name -> RecFlag

calcSynCycles :: [LTyClDecl Name] -> [SCC (LTyClDecl Name)]

calcClassCycles :: Class -> [[TyCon]]

type RoleAnnots = NameEnv (LRoleAnnotDecl Name)

extractRoleAnnots :: TyClGroup Name -> RoleAnnots

emptyRoleAnnots :: RoleAnnots

lookupRoleAnnots :: RoleAnnots -> Name -> Maybe (LRoleAnnotDecl Name)